
PAGE  59,132

seg_a		segment	byte public
		assume	cs:seg_a, ds:seg_a, es:seg_a

		org	100h

color		proc	far

start:
                call    ansihere
                mov     al,errorlevel
                cmp     al,0
                jg      ok
                jmp     loc_11
ok:		xor	ax,ax			; Zero register
		mov	bp,80h
		mov	al,[bp]
                cmp     al,0
                jg      loc_0
                mov     dx,offset data_20
                mov     ah,9
                int     21h
                jmp     loc_11

loc_0:		cmp	al,9
		jge	loc_4			; Jump if > or =
		cmp	al,2
		jge	loc_1			; Jump if > or =
		jmp	short loc_4		; (0153)
loc_1:
		mov	data_15,al		; (7116:0287=0)
                push    ax
                pop     di
		mov	si,2
		mov	cl,1Fh
		call	sub_1			; (01F3)
		cmp	bl,2
		je	loc_4			; Jump if equal
		mov	data_12,al		; (7116:0284=0)
		cmp	bl,1
		je	loc_2			; Jump if equal
		inc	bp
                dec     di
loc_2:
                sub     di,2
                jle     loc_5
		mov	si,4
		mov	cl,7
		call	sub_1			; (01F3)
		cmp	bl,2
		je	loc_4			; Jump if equal
		mov	data_13,al		; (7116:0285=0)
		cmp	bl,1
		je	loc_3			; Jump if equal
		inc	bp
                dec     di
loc_3:
                sub     di,2
                jle     loc_5
		mov	si,6
		mov	cl,0Fh
		call	sub_1			; (01F3)
		cmp	bl,2
		je	loc_4			; Jump if equal
		mov	data_14,al		; (7116:0286=0)
		jmp	short loc_5		; (0155)
loc_4:
		jmp	short loc_8		; (01BF)
loc_5:
		mov	ah,0Bh
		mov	bh,0
		mov	bl,data_14		; (7116:0286=0)
		int	10h			; Video display   ah=functn 0Bh
						;  set color from bx (CGA modes)
		mov	dx,offset data_4	; (7116:026A=1Bh)
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		xor	ax,ax			; Zero register
		mov	bx,offset data_16
		mov	al,data_12		; (7116:0284=0)
		mov	ah,al
		push	ax
		and	al,7
		xlat [bx]			; al=[al+[bx]] table
		mov	byte ptr data_7+1,al	; (7116:0278=30h)
		and	ah,8
		mov	cl,3
		shr	ah,cl			; Shift w/zeros fill
		jz	loc_6			; Jump if zero
		mov	dx,offset data_5	; (7116:0271=31h)
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
loc_6:
		pop	ax
		and	ah,10h
		mov	cl,4
		shr	ah,cl			; Shift w/zeros fill
		jz	loc_7			; Jump if zero
		mov	dx,offset data_6	; (7116:0274=35h)
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
loc_7:
		mov	dx,offset data_7	; (7116:0277=33h)
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		mov	al,data_13		; (7116:0285=0)
		and	al,7
		xlat [bx]			; al=[al+[bx]] table
		mov	byte ptr data_9+1,al	; (7116:027C=30h)
		mov	dx,offset data_9	; (7116:027B=34h)
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		mov	dx,offset data_11	; (7116:027F=1Bh)
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		mov	dx,offset data_2	; (7116:0251=44h)
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		jmp	short loc_9		; (01CD)
loc_8:
		mov	dx,offset data_1	; (7116:0228=0Dh)
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		mov	al,data_15		; (7116:0287=0)
		cmp	al,2
		jle	loc_11			; Jump if < or =
loc_9:
		mov	bx,82h
		xor	cx,cx			; Zero register
		mov	cl,data_15		; (7116:0287=0)
		dec	cx
		cmp	cx,7
		jg	loc_11			; Jump if >
		mov	si,0

locloop_10:
		mov	dl,[bx+si]
		mov	ah,2
		int	21h			; DOS Services  ah=function 02h
						;  display char dl
		inc	si
		loop	locloop_10		; Loop if cx > 0

loc_11:
		mov	dx,offset data_3	; (7116:0267=0Dh)
		mov	ah,9
		int	21h			; DOS Services  ah=function 09h
						;  display char string at ds:dx
		mov	ah,0
		int	21h			; DOS Services  ah=function 00h
						;  terminate, cs=progm seg prefx

color		endp

;
;			       SUBROUTINE
;
  
sub_1		proc	near
		mov	bl,0
		mov	ax,[bp+si]
		sub	ah,30h			; '0'
		cmp	ah,0
		jl	loc_12			; Jump if equal
		cmp	ah,9
		ja	loc_12			; Jump if above
		jmp	short loc_13		; (020A)
loc_12:
		mov	ah,0
		mov	bl,1
loc_13:
		sub	al,30h			; '0'
		cmp	al,0
		jl	loc_15			; Jump if <
		cmp	al,9
		jg	loc_15			; Jump if >
		cmp	bl,1
		je	loc_14			; Jump if equal
		mov	dl,0Ah
		mov	bh,ah
		mul	dl			; ax = reg * al
		add	al,bh
loc_14:
		cmp	al,cl
		jle	loc_ret_16		; Jump if < or =
loc_15:
		mov	bl,2

loc_ret_16:
		retn
sub_1		endp

data_1        	db	0Dh, 0Ah, 'Syntax error in COLOR parameters $'
data_2		db	'Display set to COLOR $'
data_3		db	0Dh, 0Ah, '$'
data_4		db	1Bh, '[0m', 1Bh, '[$'
data_5		db	'1;$'
data_6		db	'5;$'
data_7		db	'30;$'
data_9		db	'40m$'
data_11		db	1Bh, '[2J$'
data_12		db	0
data_13		db	0
data_14		db	0
data_15		db	0
data_16		db	'04261537'

data_20         db      0Dh, 0Ah, 'COLOR : Parameters are Foreground (0-15),'
                db      'Background (0-7),Border (0-15)'
                db      0Dh, 0Ah, '   0 = Black     8 = Gray'
                db      0Dh, 0Ah, '   1 = Blue      9 = Light Blue'
                db      0Dh, 0Ah, '   2 = Green    10 = Light Green'
                db      0Dh, 0Ah, '   3 = Cyan     11 = Light Cyan'
                db      0Dh, 0Ah, '   4 = Red      12 = Light Red'
                db      0Dh, 0Ah, '   5 = Magenta  13 = Light Magenta'
                db      0Dh, 0Ah, '   6 = Brown    14 = Yellow'
                db      0Dh, 0Ah, '   7 = White    15 = Bright White'
                db      '$'

Errorlevel    DB        0             ;exit code, default is no ANSI
DSR_string    DB        27,'[6n$'     ;Device Status Report ANSI string
NoMsg         DB        13,'ANSI.SYS not loaded$'
EraseDSR      DB        13,32,32,32,32,'$'

; The carriage return at the beginning of EraseDSR returns the cursor
; to the start of the current line and the four spaces will overwrite
; the garbage left by the DSR_string if ANSI is not loaded.

ansihere      proc      near
              mov       dx,OFFSET DSR_string  ;display the ANSI DSR_string
              mov       ah,09h
              int       21h
              mov       ah,0Bh             ;check for key in the keyboard
              int       21h                ; buffer - if there's anything
              cmp       al,0FFh            ; there, ANSI is loaded
              je        clear_key          ;go empty the buffer

; Keyboard buffer is empty so ANSI is not loaded.
              mov       dx,OFFSET EraseDSR ;erase the garbage left above
              mov       ah,09h
              int       21h
              mov       dx,OFFSET NoMsg    ;point to 'not loaded' message
              mov       ah,09h
              int       21h
              retn

; ANSI is loaded.  We must empty the keyboard buffer because it contains
; a Cursor Position Report which DOS will attempt to execute when this
; program terminates.
clear_key:    mov       ah,06h             ;get key from the keyboard buffer
              mov       dl,0FFh            ; don't wait if the buffer is empty
              int       21h                ; and don't print it to the screen
              jnz       clear_key          ;go back for more until buffer is
                                           ; empty and zero flag is set
              mov       Errorlevel,01h     ;set errorlevel = 1
              retn
ansihere      endp

seg_a		ends
		end	start
